/*
 * PROJECTNAMEASIDENTIFIER.c
 * PROJECTNAME
 *
 * Created by FULLUSERNAME on DATE.
 * Copyright YEAR ORGANIZATIONNAME. All rights reserved.
 *
 */

#include <fuse.h>
#include <string.h>
#include <errno.h>
#include <sys/stat.h>

static int
PROJECTNAMEASIDENTIFIER_fgetattr(const char *path, struct stat *stbuf,
                  struct fuse_file_info *fi) {
  memset(stbuf, 0, sizeof(struct stat));
  
  if (strcmp(path, "/") == 0) { /* The root directory of our file system. */
    stbuf->st_mode = S_IFDIR | 0755;
    stbuf->st_nlink = 3;
    return 0;
  }
  return -ENOENT;
}

static int
PROJECTNAMEASIDENTIFIER_getattr(const char *path, struct stat *stbuf) {
  return PROJECTNAMEASIDENTIFIER_fgetattr(path, stbuf, NULL);
}

static int
PROJECTNAMEASIDENTIFIER_readlink(const char *path, char *buf, size_t size) {
  return -ENOENT;
}

static int
PROJECTNAMEASIDENTIFIER_readdir(const char *path, void *buf, fuse_fill_dir_t filler,
                 off_t offset, struct fuse_file_info *fi) {
  if (strcmp(path, "/") != 0) /* We only recognize the root directory. */
    return -ENOENT;
  
  filler(buf, ".", NULL, 0);           /* Current directory (.)  */
  filler(buf, "..", NULL, 0);          /* Parent directory (..)  */
  
  return 0;
}

static int
PROJECTNAMEASIDENTIFIER_mknod(const char *path, mode_t mode, dev_t rdev) {
  return -ENOSYS;
}

static int
PROJECTNAMEASIDENTIFIER_mkdir(const char *path, mode_t mode) {
  return -ENOSYS;
}

static int
PROJECTNAMEASIDENTIFIER_unlink(const char *path) {
  return -ENOSYS;
}

static int
PROJECTNAMEASIDENTIFIER_rmdir(const char *path) {
  return -ENOSYS;
}

static int
PROJECTNAMEASIDENTIFIER_symlink(const char *from, const char *to) {
  return -ENOSYS;
}

static int
PROJECTNAMEASIDENTIFIER_rename(const char *from, const char *to) {
  return -ENOSYS;
}

static int
PROJECTNAMEASIDENTIFIER_exchange(const char *path1, const char *path2, unsigned long options) {
  return -ENOSYS;
}

static int
PROJECTNAMEASIDENTIFIER_link(const char *from, const char *to) {
  return -ENOSYS;
}

static int
PROJECTNAMEASIDENTIFIER_fsetattr_x(const char *path, struct setattr_x *attr,
                    struct fuse_file_info *fi) {
  return -ENOENT;
}

static int
PROJECTNAMEASIDENTIFIER_setattr_x(const char *path, struct setattr_x *attr) {
  return -ENOENT;
}

static int
PROJECTNAMEASIDENTIFIER_getxtimes(const char *path, struct timespec *bkuptime,
                   struct timespec *crtime) {
  return -ENOENT;
}

static int
PROJECTNAMEASIDENTIFIER_create(const char *path, mode_t mode, struct fuse_file_info *fi) {
  return -ENOSYS;
}

static int
PROJECTNAMEASIDENTIFIER_open(const char *path, struct fuse_file_info *fi) {
  return -ENOENT;
}

static int
PROJECTNAMEASIDENTIFIER_read(const char *path, char *buf, size_t size, off_t offset,
              struct fuse_file_info *fi) {
  return -ENOSYS;
}

static int
PROJECTNAMEASIDENTIFIER_write(const char *path, const char *buf, size_t size,
               off_t offset, struct fuse_file_info *fi) {
  return -ENOSYS;
}

static int
PROJECTNAMEASIDENTIFIER_statfs(const char *path, struct statvfs *stbuf) {
  memset(stbuf, 0, sizeof(*stbuf));
  stbuf->f_files = 2;  /* For . and .. in the root */
  return 0;
}

static int
PROJECTNAMEASIDENTIFIER_flush(const char *path, struct fuse_file_info *fi) {
  return 0;
}

static int
PROJECTNAMEASIDENTIFIER_release(const char *path, struct fuse_file_info *fi) {
  return 0;
}

static int
PROJECTNAMEASIDENTIFIER_fsync(const char *path, int isdatasync, struct fuse_file_info *fi) {
  return 0;
}

static int
PROJECTNAMEASIDENTIFIER_setxattr(const char *path, const char *name, const char *value,
                  size_t size, int flags, uint32_t position) {
  return -ENOTSUP;
 }

static int
PROJECTNAMEASIDENTIFIER_getxattr(const char *path, const char *name, char *value, size_t size,
                  uint32_t position) {
  return -ENOATTR;
}

static int
PROJECTNAMEASIDENTIFIER_listxattr(const char *path, char *list, size_t size) {
  return 0;
}

static int
PROJECTNAMEASIDENTIFIER_removexattr(const char *path, const char *name) {
  return -ENOATTR;
}

void *
PROJECTNAMEASIDENTIFIER_init(struct fuse_conn_info *conn) {
  FUSE_ENABLE_XTIMES(conn);
  return NULL;
}

void
PROJECTNAMEASIDENTIFIER_destroy(void *userdata) {
  /* nothing */
}

struct fuse_operations PROJECTNAMEASIDENTIFIER_operations = {
  .init        = PROJECTNAMEASIDENTIFIER_init,
  .destroy     = PROJECTNAMEASIDENTIFIER_destroy,
  .getattr     = PROJECTNAMEASIDENTIFIER_getattr,
  .fgetattr    = PROJECTNAMEASIDENTIFIER_fgetattr,
/*  .access      = PROJECTNAMEASIDENTIFIER_access, */
  .readlink    = PROJECTNAMEASIDENTIFIER_readlink,
/*  .opendir     = PROJECTNAMEASIDENTIFIER_opendir, */
  .readdir     = PROJECTNAMEASIDENTIFIER_readdir,
/*  .releasedir  = PROJECTNAMEASIDENTIFIER_releasedir, */
  .mknod       = PROJECTNAMEASIDENTIFIER_mknod,
  .mkdir       = PROJECTNAMEASIDENTIFIER_mkdir,
  .symlink     = PROJECTNAMEASIDENTIFIER_symlink,
  .unlink      = PROJECTNAMEASIDENTIFIER_unlink,
  .rmdir       = PROJECTNAMEASIDENTIFIER_rmdir,
  .rename      = PROJECTNAMEASIDENTIFIER_rename,
  .link        = PROJECTNAMEASIDENTIFIER_link,
  .create      = PROJECTNAMEASIDENTIFIER_create,
  .open        = PROJECTNAMEASIDENTIFIER_open,
  .read        = PROJECTNAMEASIDENTIFIER_read,
  .write       = PROJECTNAMEASIDENTIFIER_write,
  .statfs      = PROJECTNAMEASIDENTIFIER_statfs,
  .flush       = PROJECTNAMEASIDENTIFIER_flush,
  .release     = PROJECTNAMEASIDENTIFIER_release,
  .fsync       = PROJECTNAMEASIDENTIFIER_fsync,
  .setxattr    = PROJECTNAMEASIDENTIFIER_setxattr,
  .getxattr    = PROJECTNAMEASIDENTIFIER_getxattr,
  .listxattr   = PROJECTNAMEASIDENTIFIER_listxattr,
  .removexattr = PROJECTNAMEASIDENTIFIER_removexattr,
  .exchange    = PROJECTNAMEASIDENTIFIER_exchange,
  .getxtimes   = PROJECTNAMEASIDENTIFIER_getxtimes,
  .setattr_x   = PROJECTNAMEASIDENTIFIER_setattr_x,
  .fsetattr_x  = PROJECTNAMEASIDENTIFIER_fsetattr_x,
};
